/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package objectdbtest2;

import java.util.Collection;
import java.util.Date;
import java.util.Properties;
import java.util.UUID;
import javax.jdo.FetchGroup;
import javax.jdo.JDOHelper;
import javax.jdo.PersistenceManager;
import javax.jdo.PersistenceManagerFactory;
import javax.jdo.Query;

/**
 *
 * @author Ralf Neumann
 */
public class Main {
    
    public static void main(String[] args){
        save(100000);
        load(true);   
    }
    
    private static void load(boolean fetchAll){
        System.out.println("loading..." + new Date().toString());
        try {
            Properties properties = new Properties();
            properties.setProperty("javax.jdo.PersistenceManagerFactoryClass",
                                   "com.objectdb.jdo.PMF");
            properties.setProperty("javax.jdo.option.ConnectionURL", "objectdbtest2_db.odb");
            PersistenceManagerFactory pmf =JDOHelper.getPersistenceManagerFactory(properties);
            PersistenceManager pm = pmf.getPersistenceManager();            
            Experiment exp=null;
            try {
                if(fetchAll) pm.getFetchPlan().addGroup(FetchGroup.ALL);
                pm.currentTransaction().begin();
                Query q=pm.newQuery(Experiment.class);
                Collection res=(Collection)q.execute();
                exp=(Experiment)res.iterator().next();
                pm.currentTransaction().commit();
            }finally {
                if (pm.currentTransaction().isActive()) pm.currentTransaction().rollback();
                if (!pm.isClosed()) pm.close();
                if (!pmf.isClosed())pmf.close();
            }
            System.out.println("Experiment name:" + exp.getName());
        }catch (RuntimeException x) {
            System.err.println("Error: " + x.getMessage());
        }
        System.out.println("loading done:" + new Date().toString());
    }
    
    private static void save(int n){
        System.out.println("saving..." + new Date().toString());
        try {
            Properties properties = new Properties();
            properties.setProperty("javax.jdo.PersistenceManagerFactoryClass",
                                   "com.objectdb.jdo.PMF");
            properties.setProperty("javax.jdo.option.ConnectionURL", "objectdbtest2_db.odb");
            PersistenceManagerFactory pmf =JDOHelper.getPersistenceManagerFactory(properties);
            PersistenceManager pm = pmf.getPersistenceManager();
            try {        
                pm.currentTransaction().begin();
                TAllCell tallcell=new TAllCell("TALLCELL1");         
                pm.makePersistent(tallcell);
                Experiment exp=createExp(n, tallcell);
                pm.makePersistent(exp);
                pm.currentTransaction().commit();
                
            }finally {
                if (pm.currentTransaction().isActive()) pm.currentTransaction().rollback();
                if (!pm.isClosed()) pm.close();
                if (!pmf.isClosed())pmf.close();
            }                    
        }catch (RuntimeException x) {
            System.err.println("Error: " + x.getMessage());
        }
        System.out.println("saving done:" + new Date().toString());
    }
    
    private static Experiment createExp(int n, TAllCell tallcell){
        Experiment exp=new Experiment(UUID.randomUUID().toString());
        for(int i=0;i<n;i++){
            TranslatedRecord transrec=createTransRec(tallcell);
            exp.addRec(transrec);
        }
        return exp;
    }
        
    private static TranslatedRecord createTransRec(TAllCell tallcell){
        BaseRecord baserec=new BaseRecord(getHeader());
        String id=UUID.randomUUID().toString();
        TranslatedRecord out=new TranslatedRecord(id, baserec);
        FrequencyRecord ori1=createFrequencyRec(tallcell);
        out.addOrigin(ori1);
        FrequencyRecord ori2=createFrequencyRec(tallcell);
        out.addOrigin(ori2);
        return out;
    }
    
    private static String getHeader(){
        String out="@M01779:252:000000000-CKY57:1:1101:15883:1340 2:N:0:TTGGGA"+
"GAAGCGAGGGAGGTGGGTCCGAGGGAGGAGGGAGCGAAGGCGGTGGCTCCGAAGGATCCGGACCTAAGATTTCGGGGATTCCGTATCCGAAGCCTGGCGGTGGTGGAAGCTTGGTGCCGCGTGGCAGTGGCGGTGGTGGAAGCTTGCTAT" +
"?E.BCBGEFFG?ACGC@AD?FGCBHHGFHFC.DCHFD?D<AGG0GDC//C1D1CCD?GGHHGBFHGDFGE>>EEFG@F1CFFCGE1EEHHCFEEGEEEEHGFFFGHFGCHHGF0?CEEAE3HGFHHE?EEEF444454FDCAFBFBAA?B";
        out=UUID.randomUUID().toString() + out;
        return out;
    }
    
    private static FrequencyRecord createFrequencyRec(TAllCell tallcell){
        BaseRecord baserec=new BaseRecord(getHeader());
        String id=UUID.randomUUID().toString();
        FrequencyRecord out=new FrequencyRecord(id, baserec, 0.13, tallcell,null);
        return out;               
    }
    
    
}
